## eckit 1.26.3

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

########################################################################################################################


cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( eckit LANGUAGES CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Sandbox playground for prototyping code that may never see the light of day" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()

### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_find_lexyacc()

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    CONDITION LEXYACC_FOUND
                    REQUIRED_PACKAGES "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    CONDITION LEXYACC_FOUND )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### OpenMP

ecbuild_add_option( FEATURE OMP
                    DEFAULT OFF
                    DESCRIPTION "OpenMP linear algebra backend"
                    REQUIRED_PACKAGES "OpenMP COMPONENTS CXX" )

if( NOT TARGET OpenMP::OpenMP_CXX )
    set( eckit_HAVE_OMP 0 )
endif()

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression options

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES AEC )

### Hashing options

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "xxHash support for hashing" )

### eckit::codec

ecbuild_add_option( FEATURE ECKIT_CODEC
                    DEFAULT ON
                    DESCRIPTION "eckit::codec encoding/decoding library" )

set( eckit_CODEC_STATIC_ASSERT ON CACHE BOOL "eckit::codec static assertions" )

### eckit::maths

ecbuild_add_option( FEATURE CONVEX_HULL
                    DEFAULT OFF
                    DESCRIPTION "eckit::maths library convex hull/Delaunay triangulation" )
                    # REQUIRED_PACKAGES "Qhull COMPONENTS C CXX"

if( eckit_HAVE_CONVEX_HULL )
    find_package( Qhull REQUIRED CONFIG )

    if( NOT TARGET Qhull::qhullcpp OR NOT TARGET Qhull::qhullstatic_r )
        message( FATAL_ERROR "eckit::maths ENABLE_CONVEX_HULL requires Qhull C/C++ libraries" )
    endif()

    add_library(Qhull::Qhull INTERFACE IMPORTED)
    target_link_libraries(Qhull::Qhull INTERFACE Qhull::qhullcpp Qhull::qhullstatic_r )
endif()

### LAPACK

if( eckit_HAVE_MKL )
    set( eckit_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1 and MD4)

ecbuild_add_option( FEATURE SSL
                    DEFAULT OFF # We only use deprecated functionality from OpenSSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES "CURL 7.20" )

if(HAVE_CURL)
  ecbuild_info("Curl version ${CURL_VERSION_STRING} -- libs [${CURL_LIBRARIES}] incs [${CURL_INCLUDE_DIRS}]")
endif()

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    DEFAULT OFF
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### LibRsync

ecbuild_add_option( FEATURE RSYNC
                    DEFAULT OFF
                    DESCRIPTION "librsync implementation of the rsync algorithm"
                    REQUIRED_PACKAGES LibRsync )
if( HAVE_RSYNC )
  set( LIBRSYNC_LIBRARIES rsync )
endif()

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Sandbox playground for prototyping code that may never see the light of day" )

### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### UNICODE support

check_include_file_cxx("codecvt" HAVE_CXX_CODECVT)

ecbuild_add_option( FEATURE UNICODE
                    DEFAULT ON
                    CONDITION HAVE_CXX_CODECVT
                    DESCRIPTION "Add support for Unicode characters in Yaml/JSON parsers" )

### async io support

find_package( AIO )
ecbuild_add_option( FEATURE AIO
                    DEFAULT ON
                    CONDITION ${AIO_FOUND}
                    DESCRIPTION "support for asynchronous IO")

### c math library, needed when including "math.h"

find_package( CMath )

### realtime library implements shm_open on Linux
if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
    find_package( Realtime )
    if( REALTIME_FOUND ) # check that aio needs realtime
        set( RT_LIBRARIES ${RT_LIB} )
    endif()
else()
  set( RT_LIBRARIES "" )
endif()

### sanity checks

include(cmake/check_time_t_Y2038.cmake) # check Y2038 time_t compatibility

# check thread library is pthreads
if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${THREADS_LIBRARIES}]" )
endif()

############################################################################################
# sources

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

add_subdirectory( src )

add_subdirectory( bamboo )
add_subdirectory( doc )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files
                       SOURCES AUTHORS README.md NOTICE LICENSE
                       INSTALL ChangeLog COPYING )

############################################################################################
# finalize

set( ECKIT_LIBRARIES ${eckit_ALL_LIBS} ) # used for ecbuild_pkgconfig

foreach( _lib ${ECKIT_LIBRARIES} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== debian/changelog ===
eckit (1.26.3-1) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Jun 2024 09:53:22 +0100

eckit (1.26.2-1) unstable; urgency=medium

  * New release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Apr 2024 06:47:43 +0100

eckit (1.26.1-2) unstable; urgency=medium

  * Ensure libeckit_codec has a shared obj version number

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 15 Apr 2024 16:10:28 +0100

eckit (1.26.1-1) unstable; urgency=medium

  * New upstream release
  * Include libeckit_codec.so

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 29 Mar 2024 11:55:49 +0000

## eckit 1.26.4

=== tests/maths/CMakeLists.txt ===
ecbuild_add_test( TARGET      eckit_test_maths_eigen
                  SOURCES     test_eigen.cc
                  CONDITION   HAVE_EIGEN
                  LIBS        eckit_maths eckit
)

ecbuild_add_test( TARGET      eckit_test_maths_matrix
                  SOURCES     test_matrix.cc
                  LIBS        eckit_maths eckit
)

ecbuild_add_test( TARGET      eckit_test_maths_convex_hull
                  SOURCES     test_convex_hull.cc
                  CONDITION   HAVE_CONVEX_HULL
                  LIBS        eckit_maths eckit
)

=== src/eckit/maths/CMakeLists.txt ===
list(APPEND eckit_maths_private_libs "${LAPACK_LIBRARIES}" "${BLAS_LIBRARIES}")
list(APPEND eckit_maths_sources
    Eigen.h
    Lapack.h
    Lapack.cc
    Matrix.h
    MatrixEigen.h
    MatrixLapack.h)

if(eckit_HAVE_CONVEX_HULL)
    list(APPEND eckit_maths_sources ConvexHull.h ConvexHullN.h Qhull.cc Qhull.h)
    list(APPEND eckit_maths_private_libs Qhull::Qhull)
endif()

ecbuild_add_library(
    TARGET              eckit_maths
    TYPE                SHARED
    INSTALL_HEADERS     ALL
    HEADER_DESTINATION  ${INSTALL_INCLUDE_DIR}/eckit/maths
    SOURCES             ${eckit_maths_sources}
    PRIVATE_LIBS        ${eckit_maths_private_libs}
    PUBLIC_LIBS         eckit)

if( HAVE_EIGEN )
    # Add include directories with "SYSTEM" to avoid warnings from within Eigen headers
    target_include_directories(eckit_maths SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIRS})
endif()

=== debian/changelog ===
eckit (1.26.4-1) unstable; urgency=medium

  * New upstream release`

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Jul 2024 08:46:18 +0100

=== debian/control ===
Source: eckit
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-buildinfo, 
  ecbuild (>= 3.6.1-1~),
  chrpath,
  flex,
  bison,
  libopenblas-dev [ !ia64 !alpha !hurd-amd64 ],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  libaec-dev,
  libxxhash-dev,
  libjemalloc-dev,
  librados-dev [ !loong64 !ppc64 !sparc64 ],
  libradospp-dev [ !loong64 !ppc64 !sparc64 ],
  libbz2-dev,
  liblz4-dev,
  libeigen3-dev,
  libsnappy-dev,
  librsync-dev,
  mpi-default-dev,
  doxygen,
  python3-all,
  libssl-dev,
  libcurl4-gnutls-dev (>=  7.20),
  libncurses-dev
Standards-Version: 4.7.0
Homepage: https://github.com/ecmwf/eckit
Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest

Package: libeckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeckit0d (= ${binary:Version}), libeckit-utils (= ${binary:Version}),
  mpi-default-dev,
  libaec-dev,
  libssl-dev,
  libcurl4-gnutls-dev,
  libxxhash-dev,
  libjemalloc-dev,
  libsnappy-dev,
  liblz4-dev,
  libbz2-dev,
  libeigen3-dev,
  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, libeckit0d ( = ${binary:Version}),  ${shlibs:Depends}
Recommends: libeckit-dev
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

## eckit 1.27.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,6 +51,16 @@
 find_package( Threads REQUIRED )
 set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )
 
+ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_BUILDERS_DEBUG
+                    DEFAULT OFF
+                    DESCRIPTION "eckit::Factory builders debug"
+                    ADVANCED )
+
+ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_EMPTY_DESTRUCTION
+                    DEFAULT OFF
+                    DESCRIPTION "eckit::Factory empty destruction (system dependant)"
+                    ADVANCED )
+
 ### eckit::mpi
 
 ecbuild_add_option( FEATURE MPI
@@ -168,6 +178,34 @@
     add_library(Qhull::Qhull INTERFACE IMPORTED)
     target_link_libraries(Qhull::Qhull INTERFACE Qhull::qhullcpp Qhull::qhullstatic_r )
 endif()
+
+### eckit::geo
+
+ecbuild_add_option( FEATURE ECKIT_GEO
+                    DEFAULT OFF
+                    DESCRIPTION "eckit::geo geometry library" )
+
+ecbuild_add_option( FEATURE GEO_GRID_ORCA
+                    DEFAULT ON
+                    CONDITION eckit_HAVE_ECKIT_GEO AND eckit_HAVE_ECKIT_CODEC AND eckit_HAVE_LZ4
+                    DESCRIPTION "eckit::geo geometry library support for ORCA grids" )
+
+ecbuild_add_option( FEATURE GEO_CACHING
+                    DEFAULT OFF
+                    CONDITION HAVE_ECKIT_GEO
+                    DESCRIPTION "eckit::geo geometry library default caching behaviour" )
+
+ecbuild_add_option( FEATURE GEO_BITREPRODUCIBLE
+                    DEFAULT OFF
+                    CONDITION HAVE_ECKIT_GEO
+                    DESCRIPTION "eckit::geo geometry library bit reproducibility tests" )
+
+ecbuild_add_option( FEATURE GEO_PROJECTION_PROJ_DEFAULT
+                    DEFAULT OFF
+                    CONDITION HAVE_ECKIT_GEO
+                    DESCRIPTION "eckit::geo geometry library default to PROJ-based projections" )
+
+set( eckit_GEO_CACHE_PATH "/tmp/cache" )
 
 ### LAPACK
 
@@ -264,6 +302,13 @@
                     DEFAULT ON
                     CONDITION ${AIO_FOUND}
                     DESCRIPTION "support for asynchronous IO")
+
+### PROJ support
+
+ecbuild_add_option( FEATURE PROJ
+                    DEFAULT OFF
+                    DESCRIPTION "support PROJ-based projections"
+                    REQUIRED_PACKAGES "PROJ 9.2" )
 
 ### c math library, needed when including "math.h"
 
@@ -296,9 +341,9 @@
 set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support
 
 add_subdirectory( src )
-
 add_subdirectory( bamboo )
 add_subdirectory( doc )
+add_subdirectory( etc )
 add_subdirectory( tests )
 add_subdirectory( regressions )
 
@@ -314,10 +359,3 @@
 foreach( _lib ${ECKIT_LIBRARIES} )
     ecbuild_pkgconfig( NAME ${_lib}
                        DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
-                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
-                       LIBRARIES ${_lib} )
-endforeach()
-
-ecbuild_install_project( NAME ${PROJECT_NAME} )
-
-ecbuild_print_summary()

=== etc/CMakeLists.txt ===
add_subdirectory(eckit)

=== src/eckit/linalg/CMakeLists.txt ===
unset( eckit_la_pincludes )
unset( eckit_la_plibs )
list( APPEND eckit_la_srcs
      BackendRegistry.h
      LinearAlgebra.cc
      LinearAlgebra.h
      LinearAlgebraDense.cc
      LinearAlgebraDense.h
      LinearAlgebraSparse.cc
      LinearAlgebraSparse.h
      Matrix.cc
      Matrix.h
      SparseMatrix.cc
      SparseMatrix.h
      Tensor.cc
      Tensor.h
      Triplet.cc
      Triplet.h
      Vector.cc
      Vector.h
      dense/LinearAlgebraGeneric.cc
      dense/LinearAlgebraGeneric.h
      sparse/LinearAlgebraGeneric.cc
      sparse/LinearAlgebraGeneric.h
      types.h )

if( eckit_HAVE_ARMADILLO )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraArmadillo.cc
          dense/LinearAlgebraArmadillo.h )
    list( APPEND eckit_la_pincludes "${ARMADILLO_INCLUDE_DIRS}" )
    list( APPEND eckit_la_plibs "${ARMADILLO_LIBRARIES}" )
endif()

if( eckit_HAVE_CUDA )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraCUDA.cc
          dense/LinearAlgebraCUDA.h
          detail/CUDA.h
          sparse/LinearAlgebraCUDA.cc
          sparse/LinearAlgebraCUDA.h )
    list( APPEND eckit_la_pincludes "${CUDA_INCLUDE_DIRS}" )
    list( APPEND eckit_la_plibs "${CUDA_LIBRARIES}" "${CUDA_cusparse_LIBRARY}" )
endif()

if( eckit_HAVE_EIGEN )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraEigen.cc
          dense/LinearAlgebraEigen.h
          sparse/LinearAlgebraEigen.cc
          sparse/LinearAlgebraEigen.h )
endif()

if( eckit_HAVE_LAPACK )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraLAPACK.cc
          dense/LinearAlgebraLAPACK.h )
    list( APPEND eckit_la_plibs "${LAPACK_LIBRARIES}" )
endif()

if( eckit_HAVE_MKL )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraMKL.cc
          dense/LinearAlgebraMKL.h
          sparse/LinearAlgebraMKL.cc
          sparse/LinearAlgebraMKL.h )
    list( APPEND eckit_la_pincludes "${MKL_INCLUDE_DIRS}" )
    list( APPEND eckit_la_plibs "${MKL_LIBRARIES}" )
endif()

if( eckit_HAVE_VIENNACL )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraViennaCL.cc
          dense/LinearAlgebraViennaCL.h
          sparse/LinearAlgebraViennaCL.cc
          sparse/LinearAlgebraViennaCL.h )
    list( APPEND eckit_la_pincludes "${VIENNACL_INCLUDE_DIRS}" )
endif()

if( eckit_HAVE_OMP )
    list( APPEND eckit_la_plibs OpenMP::OpenMP_CXX )
endif()

ecbuild_add_library( TARGET             eckit_linalg TYPE SHARED
                     INSTALL_HEADERS    ALL
                     HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/linalg
                     SOURCES            ${eckit_la_srcs}
                     PRIVATE_INCLUDES   ${eckit_la_pincludes}
                     PUBLIC_LIBS        eckit
                     PRIVATE_LIBS       ${eckit_la_plibs} )

if( eckit_HAVE_EIGEN )
    # Add include directories with "SYSTEM" to avoid warnings from within Eigen headers
    target_include_directories( eckit_linalg SYSTEM PRIVATE ${EIGEN3_INCLUDE_DIRS} )
endif()

if( CUDA_FOUND )
  set( CUDA_LINK_LIBRARIES_KEYWORD PRIVATE )
  cuda_add_cublas_to_target( eckit_linalg )
endif()

=== src/eckit/maths/CMakeLists.txt ===
list(APPEND eckit_maths_private_libs "${LAPACK_LIBRARIES}" "${BLAS_LIBRARIES}")
list(APPEND eckit_maths_sources
    Eigen.h
    Lapack.cc
    Lapack.h
    Matrix.h
    Matrix3.h
    MatrixEigen.h
    MatrixLapack.h
)

if(eckit_HAVE_CONVEX_HULL)
    list(APPEND eckit_maths_sources ConvexHull.h ConvexHullN.h Qhull.cc Qhull.h)
    list(APPEND eckit_maths_private_libs Qhull::Qhull)
endif()

ecbuild_add_library(
    TARGET             eckit_maths
    TYPE               SHARED
    INSTALL_HEADERS    ALL
    HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/maths
    SOURCES            ${eckit_maths_sources}
    PRIVATE_LIBS       ${eckit_maths_private_libs}
    PUBLIC_LIBS        eckit
)

if(HAVE_EIGEN)
    # Add include directories with "SYSTEM" to avoid warnings from within Eigen headers
    target_include_directories(eckit_maths SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIRS})
endif()

=== debian/changelog ===
eckit (1.27.0-0deepin1) unstable; urgency=medium
  
  * sync with upstream 1.27.0
  * patch some tests

 -- Alphagocc <alphagocc@163.com>  Sat, 21 Sep 2024 12:21:45 +0800

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: eckit
 Section: science
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper-compat (= 13), 
+Maintainer: Alphagocc <alphagocc@163.com>
+Uploaders: Alphagocc <alphagocc@163.com>
+Build-Depends: debhelper (> 11), 
   architecture-is-64-bit,
   dh-buildinfo, 
   ecbuild (>= 3.6.1-1~),
@@ -11,13 +11,13 @@
   flex,
   bison,
   libopenblas-dev [ !ia64 !alpha !hurd-amd64 ],
-  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
-  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
+  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
+  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
   libaec-dev,
   libxxhash-dev,
   libjemalloc-dev,
-  librados-dev [ !loong64 !ppc64 !sparc64 ],
-  libradospp-dev [ !loong64 !ppc64 !sparc64 ],
+  librados-dev [ !loong64 !ppc64 !sparc64 !riscv64],
+  libradospp-dev [ !loong64 !ppc64 !sparc64 !riscv64],
   libbz2-dev,
   liblz4-dev,
   libeigen3-dev,
@@ -29,9 +29,9 @@
   libssl-dev,
   libcurl4-gnutls-dev (>=  7.20),
   libncurses-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.1.3
 Homepage: https://github.com/ecmwf/eckit
-Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest
+Vcs-Git: https://github.com/deepin-community/eckit.git
 
 Package: libeckit-dev
 Section: libdevel
@@ -48,9 +48,9 @@
   liblz4-dev,
   libbz2-dev,
   libeigen3-dev,
-  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
-  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
-  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
+  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64 riscv64],
+  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
+  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
   ${shlibs:Depends}, ${misc:Depends}
 Description: C++ toolkit for ECMWF tools and applications
  ecKit is a cross-platform c++ toolkit that supports development of tools and
@@ -91,4 +91,3 @@
  some way can be seen as a leaner substitute for some 'Boost' libraries.
  .
  ECMWF is the European Centre for Medium-Range Weather Forecasts.
-

=== debian/rules ===
#!/usr/bin/make -f

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@

## eckit 1.28.1

=== debian/changelog ===
eckit (1.28.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 19 Oct 2024 07:53:56 +0100

eckit (1.28.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Sep 2024 08:28:09 +0100

eckit (1.27.0-1) unstable; urgency=medium

  * New upstream release
  * Install  /usr/etc/eckit* to /etc/eckit in libeckit0d

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Aug 2024 07:30:44 +0100

## eckit 1.28.3

=== debian/changelog ===
eckit (1.28.3-1build1) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 07:14:12 +0100

eckit (1.28.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Nov 2024 16:03:40 +0000

eckit (1.28.2-1) unstable; urgency=medium

  * New upstream release 
  * Build with proj support, convex hull support
  * Enable ECKIT_GEO, SSL support

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Nov 2024 16:23:35 +0000

eckit (0.28.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 19 Oct 2024 07:53:56 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: eckit
 Section: science
 Priority: optional
-Maintainer: Alphagocc <alphagocc@163.com>
-Uploaders: Alphagocc <alphagocc@163.com>
-Build-Depends: debhelper (> 11), 
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
+Build-Depends: debhelper-compat (= 13), 
   architecture-is-64-bit,
   dh-buildinfo, 
   ecbuild (>= 3.6.1-1~),
@@ -11,27 +11,29 @@
   flex,
   bison,
   libopenblas-dev [ !ia64 !alpha !hurd-amd64 ],
-  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
-  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
+  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
+  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
   libaec-dev,
   libxxhash-dev,
   libjemalloc-dev,
-  librados-dev [ !loong64 !ppc64 !sparc64 !riscv64],
-  libradospp-dev [ !loong64 !ppc64 !sparc64 !riscv64],
+  librados-dev [ !loong64 !ppc64 !sparc64 ],
+  libradospp-dev [ !loong64 !ppc64 !sparc64 ],
+  libproj-dev, 
   libbz2-dev,
   liblz4-dev,
   libeigen3-dev,
   libsnappy-dev,
   librsync-dev,
+  libqhull-dev,
   mpi-default-dev,
   doxygen,
   python3-all,
   libssl-dev,
   libcurl4-gnutls-dev (>=  7.20),
   libncurses-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.7.0
 Homepage: https://github.com/ecmwf/eckit
-Vcs-Git: https://github.com/deepin-community/eckit.git
+Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest
 
 Package: libeckit-dev
 Section: libdevel
@@ -48,9 +50,9 @@
   liblz4-dev,
   libbz2-dev,
   libeigen3-dev,
-  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64 riscv64],
-  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
-  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 !riscv64],
+  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
+  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
+  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
   ${shlibs:Depends}, ${misc:Depends}
 Description: C++ toolkit for ECMWF tools and applications
  ecKit is a cross-platform c++ toolkit that supports development of tools and
@@ -91,3 +93,4 @@
  some way can be seen as a leaner substitute for some 'Boost' libraries.
  .
  ECMWF is the European Centre for Medium-Range Weather Forecasts.
+

## eckit 1.28.4

=== debian/changelog ===
eckit (1.28.4-1) unstable; urgency=medium

  * Drop B-D on dh-buildinfo
  * Drop ia64 references; no longer supported
  * New upstream release
  * Add 0d soversion to   libeckit_geo.so

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 13 Jan 2025 09:06:52 +0000

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,11 @@
 Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13), 
   architecture-is-64-bit,
-  dh-buildinfo, 
   ecbuild (>= 3.6.1-1~),
   chrpath,
   flex,
   bison,
-  libopenblas-dev [ !ia64 !alpha !hurd-amd64 ],
+  libopenblas-dev [ !alpha !hurd-amd64 ],
   libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
   liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
   libaec-dev,

=== debian/rules ===
#!/usr/bin/make -f


# TODO:
#   - Flang version doesn't build. 

export DH_VERBOSE=1

DO_TEST:=true

include /usr/share/dpkg/pkg-info.mk
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1


# JEMALLOC Turned off as it breaks magics-python currently (TLS space)

BUILD_FLAGS = \ -DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DENABLE_RSYNC=On \
	-DENABLE_CONVEX_HULL=On \
	-DENABLE_SSL=On \
	-DENABLE_ECKIT_GEO=On \
	-DENABLE_PROJ=On \
	-DENABLE_RADOS=Off \
	-DENABLE_OMP=On \
	-DENABLE_JEMALLOC=Off

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/build-*

override_dh_auto_configure:
	dh_auto_configure --  ${BUILD_FLAGS} 
	( tar axpf $(CURDIR)/../eckit_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/*/*.so.0d
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${MODULEDIR}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/eckit/*
